<%
'
' Active Directory User/Group Monitor.  Author Joe McCormack.
'
Server.ScriptTimeout = 320							' Number of seconds to allow this script to run without spawning a server generated timeout message
Dim conMethod : conMethod = "WinNT"						' WinNT or LDAP
Dim adName : adName = "ad-name"							' AD Name
Dim maxThreshold : maxThreshold = 1000						' Maximum number of user records to work with in browser after initial index of users and groups they belong to is completed; too high a number results in out of memory browser error.
Dim ugDetect : ugDetect = "1"							' New AD Object Detection - If you wish to allow this script to record group and user objects to disk so that it can detect new objects being created, and tell you the the objects that have been created since it was last run, set this value to "1".  Otherwise set to "0".  If enabled, this detection may result in the page taking several minutes to load initially.
Dim frwLocation : frwLocation = Split(Server.MapPath("."), ":\")(0) & ":\"	' Disk path to location where files containing users, groups and dates can be placed.  Location must have read/write/modify permissions.
frwLocation = frwLocation & "websites\adData\"
Dim adGroupResultsLabel : adGroupResultsLabel = "adGroupResults"		' ID of div which contains results of a group query
Dim adUserResultsLabel : adUserResultsLabel = "adUserResults"			' ID of div which contains results of a user query
adGroupsAutoCheck = Array()							' Contains list of groups to auto-check when user clicks the button
Redim Preserve adGroupsAutoCheck(0)  : adGroupsAutoCheck(0)  = "Domain Admins"
Redim Preserve adGroupsAutoCheck(1)  : adGroupsAutoCheck(1)  = "Domain Users"
Redim Preserve adGroupsAutoCheck(2)  : adGroupsAutoCheck(2)  = "Enterprise Admins"
' Do not change
Const tForReading = 1
Const tForWriting = 2
Const tForAppending = 8
Dim compiled : compiled = conMethod & "://" & adName
Dim oUser_Id : oUser_Id = ""
Dim oUser_pName : oUser_pName = ""
Dim oUser_Name : oUser_Name = ""
Dim oUser_Groups : oUser_Groups = ""
Dim userCompiled : userCompiled = ""
Dim activeProcess : activeProcess = ""
Dim nameMatch : nameMatch = ""
Dim stepCount : stepCount = 0
Dim startPointer : startPointer = 0
Dim stopPointer : stopPointer = 0
Dim svCount : svCount = 0
svNewb = Array()

'''''''''''
' Grab Data
'''''''''''
if Len(Request.Form("adGroup")) > 0 Then : activeProcess = "group" : End if
if Len(Request.Form("adUser")) > 0 Then : activeProcess = "user" : End if
if Len(Request.QueryString("blankstart")) > 0 Then : activeProcess = "blank" : End if
if Len(Request.Form("startPointer")) > 0 Then : startPointer = CInt(Request.Form("startPointer")) : End if
if Len(Request.Form("stopPointer")) > 0 Then : stopPointer = CInt(Request.Form("stopPointer")) : End if

''''''''''''''''''
' Process Requests
''''''''''''''''''
if activeProcess = "" Then
	adUsers = Array() : adUsersNames = Array() : adGroups = Array()
	''''''''''''''''''''''''''''''''
	' Retrieve list of users from AD
	''''''''''''''''''''''''''''''''
	Set container = GetObject(compiled)
	container.Filter = Array("User")
	stepCount = 0
	For Each data In container
		if Len(data.Name) > 0 Then
			Redim Preserve adUsers(stepCount) : adUsers(stepCount) = data.Name
			Redim Preserve adUsersNames(stepCount) : adUsersNames(stepCount) = data.FullName
			stepCount = stepCount + 1
		End if
	Next
	Set container = Nothing
	'''''''''''''''''''''''''''''''''
	' Retrieve list of groups from AD
	'''''''''''''''''''''''''''''''''
	Set container = GetObject(compiled)
	container.Filter = Array("Group")
	stepCount = 0
	For Each data In container
		if Len(data.Name) > 0 Then
			Redim Preserve adGroups(stepCount) : adGroups(stepCount) = data.Name
			stepCount = stepCount + 1
		End if
	Next
	Set container = Nothing
	'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	' Save the two lists into files so that new objects can be detected
	'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	if ugDetect = 1 Then
		Dim fetchDate : fetchDate = date()
		Dim currentDate : currentDate = ""
		Set fOBJ = Server.CreateObject("Scripting.FileSystemObject")
		if fOBJ.fileExists(frwLocation & "stamp.txt") = False Then
			' This is the first use - create date
			Set fSTAT = fOBJ.CreateTextFile(frwLocation & "stamp.txt", tForAppending, False)
			fSTAT.Writeline(fetchDate)
			fSTAT.Close()
			Set fSTAT = Nothing
			' This is the first use - create groups
			if UBound(adGroups) > -1 Then
				Set fSTAT = fOBJ.CreateTextFile(frwLocation & "groups.txt", tForAppending, False)
				For X = 0 TO UBound(adGroups)
					if Len(adGroups(X)) > 0 Then : fSTAT.WriteLine(adGroups(X)) : End if
				Next
				fSTAT.Close()
				Set fSTAT = Nothing
			End if
			' This is the first use - create users
			if UBound(adUsers) > -1 Then
				Set fSTAT = fOBJ.CreateTextFile(frwLocation & "users.txt", tForAppending, False)
				For X = 0 TO UBound(adUsers)
					if Len(adUsers(X)) > 0 Then : fSTAT.WriteLine(adUsers(X)) : End if
				Next
				fSTAT.Close()
				Set fSTAT = Nothing
			End if
		Else
			' This is a successive use
			Dim svGroups, svUsers, svgFlag, svuFlag
			svgFlag = 0 : svuFlag = 0
			Set fSTAT = fOBJ.OpenTextFile(frwLocation & "stamp.txt")
			currentDate = fSTAT.readline
			fSTAT.Close()
			Set fSTAT = Nothing
			if CStr(currentDate) <> CStr(fetchDate) Then
				' Load previous groups that were saved to disk
				Set fSTAT = fOBJ.GetFile(frwLocation & "groups.txt")
				Set frSTAT = fSTAT.OpenAsTextStream(tForReading, -2)
				svGroups = frSTAT.readAll() : svgFlag = 1 : svGroups = Split(svGroups, vbcrlf) : frSTAT.Close()
				Set frSTAT = Nothing
				Set fSTAT = Nothing
				' Load previous users that were saved to disk
				Set fSTAT = fOBJ.GetFile(frwLocation & "users.txt")
				Set frSTAT = fSTAT.OpenAsTextStream(tForReading, -2)
				svUsers = frSTAT.readAll() : svuFlag = 1 : svUsers = Split(svUsers, vbcrlf) : frSTAT.Close()
				Set frSTAT = Nothing
				Set fSTAT = Nothing
				' Save the new date
				Set fSTAT = fOBJ.OpenTextFile(frwLocation & "stamp.txt", tForWriting, False)
				fSTAT.Writeline(fetchDate)
				fSTAT.Close()
				Set fSTAT = Nothing
				' Save today's list of groups
				if UBound(adGroups) > -1 Then
					Set fSTAT = fOBJ.OpenTextFile(frwLocation & "groups.txt", tForWriting, False)
					For X = 0 TO UBound(adGroups)
						if Len(adGroups(X)) > 0 Then : fSTAT.WriteLine(adGroups(X)) : End if
					Next
					fSTAT.Close()
					Set fSTAT = Nothing
				End if
				' Save today's list of users
				if UBound(adUsers) > -1 Then
					Set fSTAT = fOBJ.OpenTextFile(frwLocation & "users.txt", tForWriting, False)
					For X = 0 TO UBound(adUsers)
						if Len(adUsers(X)) > 0 Then : fSTAT.WriteLine(adUsers(X)) : End if
					Next
					fSTAT.Close()
					Set fSTAT = Nothing
				End if
				' Build list of objects that are new
				Dim flagged : flagged = 0
				svCount = 0
				For X = 0 TO UBound(adGroups)
					if Len(adGroups(X)) > 0 Then
						flagged = 0
						For Y = 0 TO UBound(svGroups)
							if CStr(adGroups(X)) = CStr(svGroups(Y)) Then : flagged = 1 : End if
						Next
						if flagged = 0 Then
							Redim Preserve svNewb(svCount) : svNewb(svCount) = "New Group Object: <span onmouseover=""this.style.cursor='pointer';"" onmouseout=""this.style.cursor='default';"" onmousedown=""javascript:valShift('" & adGroups(X) & "', 'adGroup');""><u>" & adGroups(X) & "</u></span>"
							svCount = svCount + 1
						End if
					End if
				Next
				For X = 0 TO UBound(adUsers)
					if Len(adUsers(X)) > 0 Then
						flagged = 0
						For Y = 0 TO UBound(svUsers)
							if CStr(adUsers(X)) = CStr(svUsers(Y)) Then : flagged = 1 : End if
						Next
						if flagged = 0 Then
							Redim Preserve svNewb(svCount) : svNewb(svCount) = "New User Object: <span onmouseover=""this.style.cursor='pointer';"" onmouseout=""this.style.cursor='default';"" onmousedown=""javascript:valShift('" & adUsers(X) & "', 'adUser');""><u>" & adUsers(X) & "</u></span>"
							svCount = svCount + 1
						End if
					End if
				Next
				' Save new objects, if any
				if svCount > 0 Then
					if fOBJ.fileExists(frwLocation & "newbs.txt") = False Then
						Set fSTAT = fOBJ.CreateTextFile(frwLocation & "newbs.txt", tForAppending, False)
					Else
						Set fSTAT = fOBJ.OpenTextFile(frwLocation & "newbs.txt", tForWriting, False)
					End if
					For X = 0 TO UBound(svNewb)
						fSTAT.WriteLine(svNewb(X))
					Next
					fSTAT.Close()
					Set fSTAT = Nothing
				Else
					if fOBJ.fileExists(frwLocation & "newbs.txt") = True Then
						fOBJ.DeleteFile frwLocation & "newbs.txt", True
					End if
				End if
			Else
				' This is a revisit of this page on the same day - load object differences
				if fOBJ.fileExists(frwLocation & "newbs.txt") = True Then
					Dim svTemp
					svCount = 0
					Set fSTAT = fOBJ.GetFile(frwLocation & "newbs.txt")
					Set frSTAT = fSTAT.OpenAsTextStream(tForReading, -2)
					svTemp = frSTAT.readAll() : svTemp = Split(svTemp, vbcrlf) : frSTAT.Close()
					Set frSTAT = Nothing
					Set fSTAT = Nothing
					For X = 0 TO UBound(svTemp)
						Redim Preserve svNewb(svCount) : svNewb(svCount) = svTemp(X)
						svCount = svCount + 1
					Next
					Erase svTemp
				End if
			End if
			if svgFlag = 1 Then : Erase svGroups : End if
			if svuFlag = 1 Then : Erase svUsers : End if
		End if
	End if
	Set fOBJ = Nothing
End if
if activeProcess = "user" Then
	userCompiled = conMethod & "://" & adName & "/" & Request.Form("adUser") & ",user"
	Set oUser = GetObject(userCompiled)
	oUser_Id = oUser.Description : oUser_Name = oUser.FullName : oUser_pName = oUser.Name
	stepCount = 0
	For Each Group in oUser.Groups
		if stepCount = 0 Then
			oUser_Groups = Group.Name
		Else
			oUser_Groups = oUser_Groups & ", " & Group.Name
		End if
		stepCount = stepCount + 1
	Next
	Set oUser = Nothing
End if
if activeProcess = "group" Then
	userCompiled = conMethod & "://" & adName & "/" & Request.Form("adGroupUser") & ",user"
	Set oUser = GetObject(userCompiled)
	oUser_Name = oUser.FullName
	oUser_pName = oUser.Name
	stepCount = 0
	For Each Group in oUser.Groups
		if LCase(Group.Name) = LCase(Request.Form("adGroup")) Then : nameMatch = Replace(oUser_Name, """", "&quot;") & " (" & oUser_pName & ")" : End if
		if stepCount = 0 Then
			oUser_Groups = Group.Name
		Else
			oUser_Groups = oUser_Groups & ", " & Group.Name
		End if
		stepCount = stepCount + 1
	Next
	Set oUser = Nothing
End if
%>

<%
'''''''''''''''''''''''''''''''''
' Inital load of this application
'''''''''''''''''''''''''''''''''
if activeProcess = "" Then
%>
	<html>
	<head>
	<title>Active Directory User/Group Monitor</title>
	<style type="text/css">
		body { margin: 0 0 0 0; background-color: #FFFFFF; font-size: 10pt; color: #505050; font-family: verdana; }
		td { font-size: 10pt; color: #505050; font-family: verdana; }
		form { margin: 0 0 0 0; }
		.dPad { height: 10px; }
		.results { font-size: 8pt; color: #505050; font-family: verdana; }
		.selectfield { font-size: 8pt; color: #505050; font-family: verdana; }
		.inputfield { font-size: 9pt; color: #505050; font-family: verdana; }
		.btn { font-size: 9pt; color: #505050; font-family: verdana; }
	</style>
	<script language="javascript" type="text/javascript">
		<!--
		var maxThreshold = <%Response.Write(maxThreshold)%>; var ceaseAction = 0; var reportAction = 0; var spawnPosition = 0; var spawnReportData = "";
		var startPointer = 0; var stopPointer = 0; var adUserNext = 0; var oneRound = 0; var adUsersList = "";
		adUsers = new Array(); adUserGroups = new Array(); adUsersNames = new Array(); adGroupsAutoCheck = new Array();
		<%
		if UBound(adGroupsAutoCheck) > -1 Then
			stepCount = 0
			For X = 0 TO UBound(adGroupsAutoCheck)
				Response.Write "adGroupsAutoCheck[" & stepCount & "] = """ & adGroupsAutoCheck(X) & """;" & vbcrlf
				stepCount = stepCount + 1
			Next
		End if
		if UBound(adUsers) > -1 Then
			stepCount = 0
			For X = 0 TO UBound(adUsers)
				Response.Write "adUsers[" & stepCount & "] = """ & adUsers(X) & """;" & vbcrlf
				stepCount = stepCount + 1
			Next
		End if
		if UBound(adUsersNames) > -1 Then
			stepCount = 0
			For X = 0 TO UBound(adUsersNames)
				Response.Write "adUsersNames[" & stepCount & "] = """ & Replace(adUsersNames(X), """", "&quot;") & """;" & vbcrlf
				stepCount = stepCount + 1
			Next
		End if
		%>
		function valShift(source, target) {
			adUserNext = 0; adUsersList = "";
			if (document.getElementById("<%Response.Write(adGroupResultsLabel)%>")) { document.getElementById("<%Response.Write(adGroupResultsLabel)%>").innerHTML = ""; }
			if (document.getElementById("<%Response.Write(adUserResultsLabel)%>")) { document.getElementById("<%Response.Write(adUserResultsLabel)%>").innerHTML = ""; }
			if (document.getElementById(target)) { document.getElementById(target).value = source; }
			else { alert("ERROR:\n\nThe target element \"" + target + "\" could not be located on this webpage."); }
		}
		function gReportShift(group, target) {
			if (document.getElementById(target)) {
				document.getElementById(target).value = group;
				userGroupsDefault(); usersGroups();
							     }
		}
		function queryTriggered(target, msg) {
			if (document.getElementById(target)) { document.getElementById(target).innerHTML = msg; }
		}
		function userReport(id, name, groups, target) {
			var msg = "";
			msg = "<b>User Identification:</b><br />" + id + "<br /><br />";
			msg = msg + "<b>User Name:</b><br />" + name + "<br /><br />";
			msg = msg + "<b>Groups User Belongs To:</b><br />" + groups;
			if (document.getElementById(target)) { document.getElementById(target).innerHTML = msg; }
			else { alert("USER DATA:\n\n" + msg.replace(/<br \/>/gi, "\n").replace(/<b>/gi, "").replace(/<\/b>/gi, "")); }
		}
		function userGroupsDefault() {
			adUserNext = 0; adUsersList = ""; ceaseAction = 0; reportAction = 0;
			queryTriggered("<%Response.Write(adGroupResultsLabel)%>", "Your query is in progress.  Please wait.");
		}
		function ceaseActivity() {
			var msg = ""; oneRound = 1; ceaseAction = 1;
			if (reportAction == 0) {
				var target = "<%Response.Write(adGroupResultsLabel)%>";
				msg = "<b>Users Joined To Group:</b><br />" + adUsersList;
				if (document.getElementById(target)) { document.getElementById(target).innerHTML = msg; }
				else { alert("USER DATA:\n\n" + msg.replace(/<br \/>/gi, "\n").replace(/<b>/gi, "").replace(/<\/b>/gi, "")); }
					       }
			else {
			      msg = "<b>Users Joined To Group \"" + adGroupsAutoCheck[spawnPosition] + "\":</b><br />" + adUsersList;
			      if (spawnReportData.length > 0) { spawnReportData = spawnReportData + "<br />" + msg; }
			      else { spawnReportData = msg; }
			      spawnPosition = spawnPosition + 1;
			      spawnReport();
			     }
			adUsersList = "";
		}
		function showGroupReportList() {
			var msg = ""; var target = "<%Response.Write(adGroupResultsLabel)%>";
			msg = "<b>Report Groups:</b><br />The following groups have been setup to be investigated as to users who are joined to them:<br /><br />";
			for (x = 0; x < adGroupsAutoCheck.length; x++) { msg = msg + "<span onmouseover=\"this.style.cursor='pointer';\" onmouseout=\"this.style.cursor='default';\" onmousedown=\"javascript:gReportShift('" + adGroupsAutoCheck[x] + "', 'adGroup');\"><u>" + adGroupsAutoCheck[x] + "</u></span><br />"; }
			if (document.getElementById(target)) { document.getElementById(target).innerHTML = msg; }
		}
		function spawnReport() {
			oneRound = 0;
			if (spawnPosition < adGroupsAutoCheck.length) {
				document.getElementById("adGroup").value = adGroupsAutoCheck[spawnPosition];
				document.getElementById("adGroupWork").value = adGroupsAutoCheck[spawnPosition];
				document.getElementById("spawnStatus").innerHTML = "Working on <b>" + (spawnPosition + 1) + "</b> of <b>" + adGroupsAutoCheck.length + "</b> groups...";
				reportAction = 1; ceaseAction = 0; adUserNext = 0; addUsersList = "";
				usersGroups();
								      }
			else {
			      var target = "<%Response.Write(adGroupResultsLabel)%>";
			      if (document.getElementById(target)) { document.getElementById(target).innerHTML = spawnReportData; }
			      else { alert("USER DATA:\n\n" + msg.replace(/<br \/>/gi, "\n").replace(/<b>/gi, "").replace(/<\/b>/gi, "")); }
			      spawnPosition = 0; spawnReportData = ""; reportAction = 0;
			      document.getElementById("spawnStatus").innerHTML = "";
			     }

		}
		function usersGroups() {
			if (adUserNext < adUsers.length) {
				queryTriggered("<%Response.Write(adGroupResultsLabel)%>", "Your query is in progress.  Please wait.<br /><br /><b>Investigating Object:</b><br />Record: " + adUserNext + "<br />ID: " + adUsers[adUserNext] + "<br />Total Records: " + adUsers.length);
				if (oneRound == 1 && adUsers.length <= maxThreshold) {
					if (adUserGroups[adUserNext].indexOf(",") > 0) {
											var nameMatch = "";
											tBlocks = adUserGroups[adUserNext].split(",");
											for (x = 0; x < tBlocks.length; x++) {
															      if (tBlocks[x].replace(/^\s+/, "").toLowerCase() == document.getElementById("adGroup").value.toLowerCase()) { nameMatch = adUsersNames[adUserNext] + " (" + adUsers[adUserNext] + ")"; }
															     }
											groupReport(nameMatch, "");
										       }
					else {
					      if (adUserGroups[adUserNext].toLowerCase() == document.getElementById("adGroup").value.toLowerCase()) { groupReport(adUsersNames[adUserNext] + " (" + adUsers[adUserNext] + ")", ""); }
					      else { groupReport("", ""); }
					     }
										     }
				else {
				      document.getElementById("adGroupWork").value = document.getElementById("adGroup").value;
				      document.getElementById("adGroupUserWork").value = adUsers[adUserNext];
				      document.getElementById("usersQuery").submit();
				     }
							 }
			else { ceaseActivity(); }
		}
		function groupReport(name, groups) {
			if (oneRound == 0) { adUserGroups[adUserGroups.length] = groups; }
			if (name.length > 0) {
				if (adUsersList.length > 0) { adUsersList = adUsersList + ", " + name; }
				else { adUsersList = name; }
					     }
			adUserNext = adUserNext + 1;
			if (ceaseAction == 0) { usersGroups(); }
		}
		//-->
	</script>
	</head>
	<body>
	<b>Active Directory User/Group Monitor</b><br />
	With this tool you can retrieve users who belong to a group you select.  You can also run a report (if using the pre-built group list you supply) that will return users that belong to multiple groups at once.  You can also select a user to get data associated to that user, such as the groups a specific user belongs to.  Finally, if new AD object detection is enabled, this webpage will detect new groups and user objects that have been created since the last time this webpage was accessed, once per day.  Please note that it could take a <b>few minutes</b> for this page to load for the first time if new AD object detection is enabled.
	<div class="dPad"></div>
	<%
	if UBound(svNewb) > -1 Then
		''''''''''''''''''''''
		' New Object Detection
		''''''''''''''''''''''
		Response.Write "<b>Newly Created Active Directory Objects Have Been Detected</b><br />" & vbcrlf
		stepCount = 0
		For X = 0 TO UBound(svNewb)
			Response.Write svNewb(X) & "<br />" & vbcrlf
			stepCount = stepCount + 1
		Next
		stepCount = 0
		Response.Write "<div class=""dPad""></div>" & vbcrlf
		
	End if
	%>
	<div class="dPad"></div>
	<table border="1" cellpadding="2" cellspacing="0" width="100%"><tr>
	<td width="33%" valign="top"><b>AD Groups:</b><br /><br />
	<%
		'''''''''''''''''''''
		' Dump list of Groups
		'''''''''''''''''''''
		Response.Write "<select name=""groupList"" size=""15"" class=""selectfield"" onChange=""javascript:valShift(this.options[this.selectedIndex].value, 'adGroup');"">" & vbcrlf
		if UBound(adGroups) > -1 Then
			For X = 0 TO UBound(adGroups)
				Response.Write "<option value=""" & adGroups(X) & """> " & adGroups(X) & " </option>" & vbcrlf
			Next
		End if
		Response.Write "</select>" & vbcrlf
		Response.Write "<br />" & UBound(adGroups) & " Groups Detected" & vbcrlf
	%>
	</td>
	<td width="33%" valign="top"><b>Options:</b><br /><br />
	In order to get a list of users that are joined to a group, click on the group to the left and then single-click on the "Retrieve Users of Group" button below.  This process may take a few minutes to complete.<br /><br />
	Group Selected:<br />
	<input type="text" name="adGroup" id="adGroup" size="25" class="inputfield" value="" /><br /><br />
	<input type="button" value="Retrieve Users of Group" class="btn" onmousedown="javascript:userGroupsDefault();usersGroups();" />
	&nbsp;&nbsp;<input type="button" value="Stop" class="btn" onmousedown="javascript:ceaseActivity();" />
	<%
	if UBound(adGroupsAutoCheck) > -1 Then
		Response.Write "<br /><br /><input type=""button"" value=""Run Report"" class=""btn"" onmousedown=""javascript:spawnReport();"" />" & vbcrlf
		Response.Write "&nbsp;&nbsp;<span onmouseover=""this.style.cursor='pointer';"" onmouseout=""this.style.cursor='default';"" onmousedown=""javascript:showGroupReportList();""><u>View Group List</u></span>" & vbcrlf
		Response.Write "<div id=""spawnStatus"" style=""display: block; position: relative;""></div>" & vbcrlf
	End if
	%>
	<form method="post" name="usersQuery" id="usersQuery" action="<%Response.Write(Request.ServerVariables("SCRIPT_NAME"))%>" target="callBack">
		<input type="hidden" name="adGroup" id="adGroupWork" value="" />
		<input type="hidden" name="adGroupUser" id="adGroupUserWork" value="" />
	</form>
	</td>
	<td width="33%" valign="top"><b>Results:</b><br /><br />
		<div id="<%Response.Write(adGroupResultsLabel)%>" class="results"></div>
	</td>
	</tr></table>
	<div class="dPad"></div>
	<table border="1" cellpadding="2" cellspacing="0" width="100%"><tr>
	<td width="33%" valign="top"><b>AD Users:</b><br /><br />
	<%
		''''''''''''''''''''
		' Dump list of Users
		''''''''''''''''''''
		Response.Write "<select name=""userList"" size=""15"" class=""selectfield"" onChange=""javascript:valShift(this.options[this.selectedIndex].value, 'adUser');"">" & vbcrlf
		if UBound(adUsers) > -1 Then
			For X = 0 TO UBound(adUsers)
				Response.Write "<option value=""" & adUsers(X) & """> " & adUsers(X) & " </option>" & vbcrlf
			Next
		End if
		Response.Write "</select>" & vbcrlf
		Response.Write "<br />" & UBound(adUsers) & " Users Detected" & vbcrlf
	%>
	</td>
	<td width="33%" valign="top"><b>Options:</b><br /><br />
	In order to get a list of groups a user is joined to, click on the user to the left and then single-click on the "Retrieve Groups User Joined To" button below.  This process may take a few minutes to complete.<br /><br />
	<form method="post" action="<%Response.Write(Request.ServerVariables("SCRIPT_NAME"))%>" onsubmit="javascript:queryTriggered('<%Response.Write(adUserResultsLabel)%>', 'Your query is in progress.  Please wait.')" target="callBack">
		User Selected:<br />
		<input type="text" name="adUser" id="adUser" size="25" class="inputfield" value="" /><br /><br />
		<input type="submit" value="Retrieve Groups User Joined To" class="btn" />
	</form>
	</td>
	<td width="33%" valign="top"><b>Results:</b><br /><br />
		<div id="<%Response.Write(adUserResultsLabel)%>" class="results"></div>
	</td>
	</tr></table>
	<iframe name="callBack" src="<%Response.Write(Request.ServerVariables("SCRIPT_NAME"))%>?blankstart=true" style="display: none; visibility: hidden;"></iframe>
	</body>
	</html>
<%
Erase adUsers : Erase adUsersNames : Erase adGroups : Erase adGroupsAutoCheck : Erase svNewb
End if
%>
<%
''''''''''''''''''''''''''''''''
' Fetch groups user is joined to
''''''''''''''''''''''''''''''''
if activeProcess = "user" Then
%>
	<html><head><title>Groups User Is Attached To</title></head>
	<body onload="javascript:parent.userReport('<%Response.Write(oUser_Id)%>', '<%Response.Write(oUser_Name & " (" & oUser_pName & ")")%>', '<%Response.Write(oUser_Groups)%>', '<%Response.Write(adUserResultsLabel)%>');"></body>
	</html>
<%
End if
%>
<%
''''''''''''''''''''''''''''''''''''''''''''''
' Fetch collection of users belonging to group
''''''''''''''''''''''''''''''''''''''''''''''
if activeProcess = "group" Then
%>
	<html><head><title>User Attached To Group</title></head>
	<body onload="javascript:parent.groupReport('<%Response.Write(nameMatch)%>', '<%Response.Write(oUser_Groups)%>');"></body>
	</html>
<%
End if
%>
<%
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Embed blank page for iframe so IE does not generate an "error"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
if activeProcess = "blank" Then
%>
	<html><title>Starting Blank</title><body></body></html>
<%
End if
%>